/*
	fuboy - a gameboy emulator
	/mic 2009
*/

#include "gbz80.h"
#include "gui.h"
#include "memory.h"
#include "ppu.h"


extern int num_roms;
extern char rom_table;
extern char rom_sizes;

bool			run,quit,romLoaded;
unsigned long	templ;
int				debg=0;


bool load_rom(int i) {
	int size;
	int *sizes;
	unsigned char **roms;

	roms = (unsigned char **)(&rom_table);
	cart = roms[i];
	sizes = (int*)(&rom_sizes);
	size = sizes[i];

	// Debug stuff
	//*(char**)(0x6030000) = cart;
	//*(int*)(0x6030004) = size;

	numBanks = size>>14;


	return true;
}


void idle() {
	while ((!run) && (!quit)) {
		gui_process();
 	}
}


void reset_machine() {
	mem_reset();
	cpu_reset();
	ppu_reset();
}

void emulate() {
	while (run) {
		cpu.cycles = 0;
		ppu_mode(0);
		cpu_execute(204);
		ppu_mode(2);
		cpu_execute(285);
		ppu_mode(3);
		cpu_execute(456);
		if (ppu.scanline==0)
			gui_present(NULL);
		gui_process();
	}
}


void shut_down() {
	gui_close();
}


int main() {
	gui_init();

	quit = false;
	run = false;
	romLoaded = false;

	romLoaded = load_rom(0);
	reset_machine();
	run = true;

	while (!quit) {
		//idle();
		emulate();
	}
	shut_down();

	return 0;
}



