/*
	gui.cpp
	fuboy 32x gui
	/mic 2009
*/

#include "gui.h"


/* Create a 5:5:5 RGB color with the MSB set */
#define COLOR(r,g,b)    (((r)&0x1F)|((g)&0x1F)<<5|((b)&0x1F)<<10|0x8000)

uint16 currentFB=0;
uint16 lineOffs;
uint16 p;
vu8 *frameBuffer = &MARS_FRAMEBUFFER;
vu16 *frameBuffer16 = &MARS_FRAMEBUFFER;
vu16 *palette = &MARS_CRAM;
int fbOffs,ltOffs;


void gui_init() {
	int i,j,y;

	// Wait for the SH2 to gain access to the VDP
	while ((MARS_SYS_INTMSK & MARS_SH2_ACCESS_VDP) == 0) {}

	// Set 8-bit paletted mode, 224 lines
	MARS_VDP_DISPMODE = MARS_224_LINES | MARS_VDP_MODE_256;

	MARS_VDP_FBCTL = currentFB;

	palette[0] = COLOR(31, 30, 25);
	palette[1] = COLOR(16, 24, 15);
	palette[2] = COLOR(2, 13, 12);
	palette[3] = COLOR(1, 3, 0);
}


void gui_close() {
}


void gui_process() {
}


void gui_present(unsigned char *vscreen) {
	int i,y;

	// Flip the framebuffer selection bit and wait for it to take effect
	MARS_VDP_FBCTL = currentFB ^ 1;
	while ((MARS_VDP_FBCTL & MARS_VDP_FS) == currentFB) {}
	currentFB ^= 1;

	fbOffs = 0x100;
	ltOffs = 0;
	y = 0;
	for (i=0; i<224; i++)
	{
		frameBuffer16[ltOffs++] = (y>>8)*160 + 0x100;
		y += 164;
	}
}
